package exam2;

import java.util.HashSet;
import java.util.Set;

public class Scratch {

	public static boolean isAnagram(String one, String two) {
		if (one == null && two == null) {
			throw new IllegalArgumentException("Both inputs shouldn't be null");
		} else if (one == null) {
			return false;
		} else if (two == null) {
			return false;
		}

		if (one.equals(two)) {
			return true;
		}
		if (one.length() > two.length()) {
			return false;
		} else if (two.length() > one.length()) {
			return false;
		}

		Set<Character> oneSet = new HashSet<Character>();
		for (int i = 0; i < one.length(); i++) {
			oneSet.add(one.charAt(i));
		}

		for (int j = 0; j < two.length(); j++) {
			char twoChar = two.charAt(j);
			if (!oneSet.contains(twoChar)) {
				return false;
			}
		}

		Set<Character> twoSet = new HashSet<Character>();
		for (int k = 0; k < two.length(); k++) {
			twoSet.add(two.charAt(k));
		}
		for (int l = 0; l < two.length(); l++) {
			char oneChar = one.charAt(l);
			if (!twoSet.contains(oneChar)) {
				return false;
			}
		}
		return true;

	}

}
